using System;
using System.Text;
using System.Collections;

namespace Indexer
{
	public class Radio
	{
		public void TurnOn(bool on)
		{
			if(on)
				Console.WriteLine("Jamming...");
			else
				Console.WriteLine("Quiet time...");
		}
	}


	public class Car
	{
		// Constant for maximum speed.
		public const int maxSpeed = 100;

		// Internal state data.
		private int currSpeed;
		private string petName;
		private int carID;

        #region Properties
		public int CurrSpeed
		{
			get
			{
				return currSpeed;
			}

			set
			{
				currSpeed = value;
			}
		}

		public string PetName
		{
			get
			{
				return petName;
			}

			set
			{
				petName = value;
			}
		} 
        #endregion

		// Is the car still operational?
		private bool carIsDead;

		// A car has-a radio.
		private Radio theMusicBox = new Radio();

		public Car() { }
		public Car(string name, int currSp)
		{
			currSpeed = currSp;
			petName = name;
		}
		public Car(string name, int currSp, int id)
		{
			currSpeed = currSp;
			petName = name;
			carID = id;
		}


		public void CrankTunes(bool state)
		{
			// Delegate request to inner object.
			theMusicBox.TurnOn(state);
		}

	}



	
	// Cars - is a container of Car objects. 
	public class Cars 
	{ 
		public Car[] carArray; 

		//     Cars     Car 
		public Cars() 
		{ 
			carArray = new Car[4]; 
			carArray[0] = new Car("FeeFee", 200,0); 
			carArray[1] = new Car("Clunker", 90, 0); 
			carArray[2] = new Car("Zippy", 30, 0); 
			carArray[3] = new Car("Fred", 30, 0); 

		} 
	} 


	
	
	public class CarApp 
	{ 
		public static void Main(string[] args) 
		{ 
			Console.WriteLine("***** Fun with Indexers *****\n"); 

			// Assume the Garage type has an indexer method. 
			Cars carLot = new Cars(); 

			carLot.carArray[0] = new Car("FeeFee", 200); 
			carLot.carArray[1] = new Car("Clunker", 90); 
			carLot.carArray[2] = new Car("Zippy", 30); 

			// Now obtain and display each item. 
			for (int i = 0; i < 3; i++) 
			{ 
				Console.WriteLine("Car number: {0}", i); 
				Console.WriteLine("Name: {0}", carLot.carArray[i].PetName); 
				Console.WriteLine("Max speed: {0}", carLot.carArray[i].CurrSpeed); 
				Console.WriteLine(); 
			} 
			Console.ReadLine(); 
		} 
	} 

}
