using System;
//using System.Collections.Generic;
using System.Text;

namespace OverloadedOps
{

	public class Point 
	{ 
		private int x, y; 
		public Point() {}
		public Point(int xPos, int yPos) 
		{ 
			x = xPos; 
			y = yPos; 
		} 

		// AddPoints         
		public static Point AddPoints(Point p1, Point p2) 
		{ 
			return new Point(p1.x + p2.x, p1.y + p2.y); 
		} 

		// SSubtractPoints        
		// 
			public static Point SSubtractPoints(Point p1, Point p2) 
			{ 

				int newX = (p1.x - p2.x); 
				if(newX < 0) 
					throw new ArgumentOutOfRangeException(); 

				int newY = (p1.y - p2.y); 
				if(newY < 0) 
					throw new ArgumentOutOfRangeException(); 


				return new Point(newX, newY); 


			} 

		// overloaded operator +. 
		public static Point operator +(Point p1, Point p2) 
		{ 
			return AddPoints(p1, p2); 
		} 


		// overloaded operator -. 
		public static Point operator -(Point p1, Point p2) 
		{ 
			return SSubtractPoints(p1, p2); 
		} 

		public override string ToString() 
		{ 
			return ("X pos: " + this.x + "  Y pos: " + this.y); 
		} 
	} 
	
	class Class1
	{
		static int Main(string[] args) 
		{ 
			Console.WriteLine("***** Fun with Overloaded Operators *****\n"); 

			// Make two points
			Point ptOne = new Point(100, 100);
			Point ptTwo = new Point(40, 40);
			Console.WriteLine("ptOne = {0} ", ptOne);
			Console.WriteLine("ptTwo = {0} ", ptTwo);

			Point bigPoint = ptOne + ptTwo;
			Console.WriteLine("Here is the bigPoint: {0} ", bigPoint.ToString());
      
			Point minorPoint = ptOne - ptTwo;
			Console.WriteLine("Here is the minorPoint: {0} ", minorPoint.ToString());

			Point finalPt = Point.AddPoints(ptOne, ptTwo); 
			Console.WriteLine("My final point: {0}", finalPt.ToString()); 

			Point final_minPt = Point.SSubtractPoints(ptOne, ptTwo); 
			Console.WriteLine("My final_min point: {0}", final_minPt.ToString()); 
			Console.ReadLine();

			return 0; 
		} 	
	}
}
