using System;
using System.Collections;

namespace ObjCompWithOps
{

	public class Car  : IComparable
	{
		// Constant for maximum speed.
		public const int maxSpeed = 100;

		// Internal state data.
		private int currSpeed;
		private string petName;
		private int carID;

        #region Properties
	
		// 
		//------------------------------------
		public int MaxSpeed
		{
			get
			{
				return currSpeed;
			}

			set
			{
				currSpeed = value;
			}
		}

		//----------------------------------		
		public int ID
		{
			get
			{
				return carID;
			}

			set
			{
				carID = value;
			}
		}
		//---------------------------------		
		public string PetName
		{
			get
			{
				return petName;
			}

			set
			{
				petName = value;
			}
		} 
		//------------------------------------
		#endregion

		// Is the car still operational?
		//		private bool carIsDead;

		//
		public Car() { }
		public Car(string name, int currSp)
		{
			currSpeed = currSp;
			petName = name;
		}
        
		public Car(string name, int currSp, int id)
		{
			currSpeed = currSp;
			petName = name;
			carID = id;
		}

		int IComparable.CompareTo(object obj) 
		{ 

			Car temp = (Car)obj; 
			if (this.carID > temp.carID) 
				return 1; 
			if (this.carID < temp.carID) 
				return -1; 
			else 
				return 0; 

		} 

	
		public int CompareTo(object o) 
		{ 

			Car temp = (Car)o; 
			if(this.carID > temp.carID) 
				return 1; 
			else 
				return 0; 

		} 

		public static bool operator < (Car c1, Car c2) 
		{ 

			IComparable itfComp = (IComparable)c1; 
			return (itfComp.CompareTo(c2) < 0); 

		} 

		public static bool operator > (Car c1, Car c2) 
		{ 

			IComparable itfComp = (IComparable)c1; 
			return (itfComp.CompareTo(c2) > 0); 

		} 

		public static bool operator <= (Car c1, Car c2) 
		{ 

			IComparable itfComp = (IComparable)c1; 
			return (itfComp.CompareTo(c2) <= 0); 

		} 

		public static bool operator >= (Car c1, Car c2) 
		{ 

			IComparable itfComp = (IComparable)c1; 
			return (itfComp.CompareTo(c2) >= 0); 

		} 

	
	}
	
	
	//  Car    
	public class Cars : IEnumerable, IEnumerator 
	{ 
		private Car[] myAutos; 

		//       
		int pos = -1; 



		//
		public Cars() 
		{ 
			//       Car      
			// Make an array of Car types. 
			Car[] myAutos = new Car[5]; 
			myAutos[0] = new Car("Rusty", 80, 1); 
			myAutos[1] = new Car("Mary", 40, 234); 
			myAutos[2] = new Car("Viper", 40, 34); 
			myAutos[3] = new Car("Mel", 40, 4); 
			myAutos[4] = new Car("Chucky", 40, 5); 

			
		} 


		
		//   IEnumerator 
		public bool MoveNext() 
		{ 
			if(pos < myAutos.Length) 
			{ 
				pos++; 
				return true; 
			} 
			else 
				return false; 
		} 

		public void Reset() 
		{ 
			pos = 0; 
		} 

		public object Current 
		{ 
			get 
			{ 
				return myAutos[pos];
			} 
		} 
		//   IEnumerable 
		public IEnumerator GetEnumerator() 
		{ 
		{
			return (IEnumerator)this; 
		} 
		} 
	} 



	class Program 
	{ 

		static void Main(string[] args) 
		{ 
			Console.WriteLine("***** Fun with IComparable *****\n"); 

			// Make an array of Car types. 
			Car[] myAutos = new Car[5]; 
			myAutos[0] = new Car("Rusty", 80, 1); 
			myAutos[1] = new Car("Mary", 40, 234); 
			myAutos[2] = new Car("Viper", 40, 34); 
			myAutos[3] = new Car("Mel", 40, 4); 
			myAutos[4] = new Car("Chucky", 40, 5); 

			if (myAutos[0] < myAutos[4]) 
				Console.WriteLine(" Rusty is less than Chacky "); 
			else 
				Console.WriteLine(" Chacky is less than Rusty "); 
		

			// Dump current array. 
			Console.WriteLine("Here is the unordered set of cars:"); 
			foreach (Car c in myAutos) 
				Console.WriteLine("{0} {1}", c.ID, c.PetName); 

			// Now, sort them using IComparable! 
			Array.Sort(myAutos); 


			// Dump sorted array. 
			Console.WriteLine("\nHere is the ordered set of cars:"); 
			foreach (Car c in myAutos) 
				Console.WriteLine("{0} {1}", c.ID,c.PetName); 

			Console.ReadLine(); 

		} 
	} 






}
