using System;

namespace CarDelegate
{
	public class Car
	{
		// ! 
		private bool isDirty; //   ? 
		private bool shouldRotate; //   ? 

		//  isDirty 
		public bool Dirty 
		{ 
			get {return isDirty;}
			set {isDirty = value;} 
		} 
		//  shouldRotate 
		public bool Rotate 
		{ 
			get {return shouldRotate;} 
			set {shouldRotate = value;} 
		} 


		#region Basic Car members...
		#region Nested radio
		// Radio as nested type
		public class Radio
		{
			public void TurnOn(bool on)
			{
				if (on)
					Console.WriteLine("Jamming...");
				else
					Console.WriteLine("Quiet time...");
			}
		}
        #endregion

		// Internal state data.
		private int currSpeed;
		private int maxSpeed;
		private string petName;

		// Is the car alive or dead?
//		bool carIsDead;

		// A car has-a radio.
		private Radio theMusicBox = new Radio();

		public Car()
		{
			maxSpeed = 100;
		}

		public Car(string name, int max, int curr)
		{
			currSpeed = curr;
			maxSpeed = max;
			petName = name;
		}

		//    
		public Car(string name, int max, int curr, bool dirty, bool rotate) 
		{ 
			currSpeed = curr;
			maxSpeed = max;
			petName = name;
			isDirty = dirty; 
			shouldRotate = rotate; 
		} 

		
		public void CrankTunes(bool state)
		{
			theMusicBox.TurnOn(state);
		}

		
		#endregion 

	}

	// -  ,    .   
	//    - ,    
	//   Car    : 

	public delegate void CarDelegate(Car c); 

	
	class CarApp
	{
			static void Main(string[] args)
			{
				Console.WriteLine("***** Delegates as event enablers *****");

				Console.ReadLine();
			}


	}
}
