using System; 
using System.Text; 
using System.Collections; 

namespace CarEvents 
{ 

	public class Car 
	{ 
#region Basic Car members... 

		// Internal state data. 
		private int currSpeed; 
		private int maxSpeed; 
		private string petName; 


		// Is the car alive or dead? 
		// bool carIsDead; 


		//       
		private bool dead; 


		//. ,       
		public delegate void EngineHandler(string msg); 


		//  
		public static event EngineHandler Exploded; 
		public static event EngineHandler AboutToBlow; 

		public Car() 
		{ 

			maxSpeed = 100; 

		} 

		public Car(string name, int max, int curr) 
		{ 

			currSpeed = curr; 
			maxSpeed = max; 
			petName = name; 

		} 
#endregion 


		public void SpeedUp(int delta) 
		{ 

			if(dead) 
			{ 
				if(Exploded != null) 
					Exploded("Sorry, this car is dead"); 
			} 
			else 
			{ 
				currSpeed += delta; 

				if(10 == maxSpeed - currSpeed) 

					if(AboutToBlow != null) 
						AboutToBlow("Carefool, approaching terminal speed"); 

				if(currSpeed >= maxSpeed) 

					dead = true; 
				else 
					Console.WriteLine("\t CurrSpeed = {0}", currSpeed); 

			} 
		} 
	} 

	class CarApp 
	{ 

		static int Main(string[] args) 
		{ 
			//   Car  
			Car c1 = new Car("SlugBug", 100, 10); 

			//   
			Car.Exploded += new Car.EngineHandler(OnBlowUp); 
			Car.Exploded += new Car.EngineHandler(OnBlowUp2); 
			Car.AboutToBlow += new Car.EngineHandler(OnAboutToBlow); 

			//  (      
			for(int i = 0; i < 10; i++) c1.SpeedUp(20); 

			//   
			Car.Exploded -= new Car.EngineHandler(OnBlowUp); 
			Car.Exploded -= new Car.EngineHandler(OnBlowUp2); 
			Car.AboutToBlow -= new Car.EngineHandler(OnAboutToBlow); 


			//     
			for(int i = 0; i < 10; i++) c1.SpeedUp(20); 

			Console.ReadLine(); 
			return 0; 

		} 

	
		//   Exploded 
		public static void OnBlowUp(string s) 
		{ 

			Console.WriteLine(" Message from car: {0}", s); 
		} 

		//   Exploded 
		public static void OnBlowUp2(string s)
		{ 

			Console.WriteLine(" - AGAIN I say: {0}", s); 
		} 


		// OnAboutToBlow 
		public static void OnAboutToBlow(string s)
		{ 

			Console.WriteLine(" Message from car: {0}", s); 
		} 
	
	
	} 
} 
